// Cell.java
// CS205 Fall 2006

public class Cell extends SimObject {
	private/* nonnull */CellState state;

	public Cell()
	// EFFECTS: Initializes this to a dead cell.
	{
		super();
		state = CellState.createDead();
	}

	public/* nonnull */java.awt.Color getColor()
	// EFFECTS: Returns the display color for this.
	{
		return state.getColor();
	}

	public boolean setState(/* nonnull */CellState s)
	// MODIFIES: this
	// EFFECTS: Sets the cell's current state to s. Returns true iff the new
	// state is different from the current state.
	{
		if (state.equals(s)) {
			return false;
		} else {
			state = s;
			return true;
		}
	}

	public/* nonnull */CellState getState()
	// EFFECTS: Returns the cell's current state.
	{
		return state;
	}

	boolean isAlive()
	// EFFECTS: Returns true if the cell is alive, false otherwise.
	{
		return state.isAlive();
	}

	public/* nonnull */CellState getNextState()
	// REQUIRES: init has previously been called for this.
	// EFFECTS: Returns next state value for this.
	// Note: For the underlying Cell class, the next state is always the
	//   current state.  Override this method to implement
	//   different cell automata rules.
	{
		return state;
	}
}
