// CS205 Fall 2006
// CellThread.java

class CellThread extends Thread {
	// Time (in milliseconds) to sleep between steps
	private final static int SLEEP_DELAY = 500; 

	private CellAutomata ca;

	private boolean suspended;

	public CellThread(CellAutomata ca) {
		this.ca = ca;
		this.suspended = false;
	}

	public void suspendThread() {
		suspended = true;
	}

	public void run() {
		while (!suspended) {
			ca.step();
			try {
				Thread.sleep(SLEEP_DELAY);
			} catch (InterruptedException e) {
				System.out.println("Thread interrupted");
				break;
			}
		}
	}
}
