// CS205 Fall 2006
// Coordinate.java

import java.lang.String;
import java.util.Vector;
import java.util.Enumeration;

public class Coordinate {
	private int x;
	private int y;

	Coordinate(int p_x, int p_y)
	// EFFECTS: Constructs a new Coordinate (p_x, p_y).
	{
		x = p_x;
		y = p_y;
	}

	Coordinate(/* nonnull */Coordinate c) {
		x = c.getX();
		y = c.getY();
	}

	public int getX()
	// EFFECTS \result == x;
	{
		return x;
	}

	public int getY()
	// EFFECTS \result == y;
	{
		return y;
	}

	public void setX(int p_x)
	// EFFECTS this.x == p_x;
	{
		x = p_x;
	}

	public void setY(int p_y)
	// EFFECTS this.y == p_y;
	{
		y = p_y;
	}

	public String toString() {
		return "(" + x + ", " + y + ")";
	}

	public boolean equals(Object c) {
		if (c == null || !(c instanceof Coordinate)) {
			return false;
		} else {
			Coordinate b = (Coordinate) c;
			return (x == b.getX() && y == b.getY());
		}
	}

	static public String outputCoordinates(/* nonnull */Vector<Coordinate> coords) {
		StringBuffer res = new StringBuffer(coords.size() * 8);
		Enumeration<Coordinate> e = coords.elements();

		while (e.hasMoreElements()) {
			Coordinate c = e.nextElement();
			res.append(c.x + "," + c.y + ";");
		}

		return new String(res);
	}
}
