// CS205 Fall 2006
// ExtremeLifeCell.java

import java.util.Enumeration;

public class ExtremeLifeCell extends Cell {
	public CellState getNextState()
	// EFFECTS: Returns the next state for this cell.
	//          The next state will be alive if this cell or any of its neighbors
	//          is currently alive.
	{
		Enumeration<SimObject> neighbors = getNeighbors();
		while (neighbors.hasMoreElements()) {
			SimObject neighbor = neighbors.nextElement();
			if (neighbor instanceof Cell) {
				Cell cell = (Cell) neighbor;
				if (cell.isAlive()) {
					// If the cell has at least one neighboring cell
					// that is alive, this cell should become alive.
					return CellState.createAlive();
				}
			}
		}

		// No alive neighbor found, next state is current state
		return getState();
	}
}
