// CS205 Fall 2006
// GridDisplay.java

import javax.swing.*;
import java.awt.*;

public class GridDisplay extends JPanel {
	protected /*nonnull*/ Grid grid;
	static final long serialVersionUID = 0L;

	GridDisplay(/* nonnull */Grid grid) {
		this.grid = grid;
		setOpaque(false); // This is necessary to make painting work
	}

	int getRealWidth() {
		return getVisibleRect().width; 
	}

	int getRealHeight() {
		return getVisibleRect().height;
	}

	protected int getSquareWidth()
	{
		int swidth = getRealWidth() / (grid.maxX() + 1);
		
		if (swidth > 0) {
			return swidth;
		} else {
			return 1;
		}
	}

	protected int getSquareHeight()
	{
		int sheight = getRealHeight() / (grid.maxY() + 1);

		if (sheight > 0) {
			return sheight;
		} else {
			return 1;
		}
	}

	protected int getHorizontalOffset() {
		int offset = (getRealWidth() - (getSquareWidth() * (grid.maxX() + 1))) / 2;
		return offset;
	}

	protected int getVerticalOffset() {
		int offset = (getRealHeight() - (getSquareHeight() * (grid.maxY() + 1))) / 2;
		return offset;
	}

	public SimObject getObjectAt(int x, int y) {
		int grid_x = (x - getHorizontalOffset()) / getSquareWidth();
		int grid_y = Math.abs(((y - getVerticalOffset()) / getSquareHeight())
				- grid.maxY());

		return grid.getObjectAt(grid_x, grid_y);
	}

	public void paintComponent(Graphics g) throws RuntimeException {
		int squarewidth = getSquareWidth();
		int squareheight = getSquareHeight();

		int hoffset = getHorizontalOffset();
		int voffset = getVerticalOffset();

		for (int x = 0; x <= grid.maxX(); x++) {
			for (int y = 0; y <= grid.maxY(); y++) {
				SimObject tmp = grid.grabObjectAt(x, y);

				if (tmp == null) {
					g.setColor(Color.gray.darker()); 
				} else {
					g.setColor(tmp.getColor());
				}

				g.fillRect(hoffset + x * squarewidth, voffset
						+ ((grid.maxY() - y) * squareheight), squarewidth - 1,
						squareheight - 1);
			}
		}
	}
}
